﻿local mod = BigWigs:NewBoss("Professor Putricide AVR", "Icecrown Citadel")
if not mod then return end
mod:RegisterEnableMob(36678, 37562, 37697)
mod.toggleOptions = {72295,72855}

function mod:OnBossEnable()
	self:RegisterMessage("BigWigs_Message")
	self.scene=AVR:GetTempScene("AVR_BIGWIGS")
	self.scene:ClearScene()
	self.scene.visible=true
	
	self:Log("SPELL_AURA_APPLIED", "UnboundPlague", 72855, 72856) 
	self:Log("SPELL_AURA_REMOVED", "UnboundPlagueRemoved", 72855, 72856)

	--self:Log("SPELL_AURA_APPLIED", "PlagueSickness",  70953, 73117) 
	--self:Log("SPELL_AURA_REMOVED", "PlagueSicknessRemoved",  70953, 73117)
	
	self.unboundMeshes={}
	self.unboundMeshes2={}
	self.sicknessMeshes={}
end

function mod:OnBossDisable()
	self:UnregisterMessage("BigWigs_Message")
	self.scene:ClearScene()
	self.scene.visible=false
end

function mod:UnboundPlague(player, spellId, _, _, spellName)
--	if bit.band(self.db.profile[72855], BigWigs.C.MESSAGE) ~= BigWigs.C.MESSAGE then return end

	local m=self.unboundMeshes[player]
	if m then m:Remove() end
	m=self.unboundMeshes2[player]
	if m then m:Remove() end
	
	_, _, _, _, _, duration, expirationTime = UnitDebuff(player, spellName)
	if not duration or not expirationTime then return end
	
	m=AVR:AddCircleWarning(self.scene,player,true,3,nil,1,0.5,0,nil,nil,true)
	m:SetTimer(60,expirationTime)
	self.unboundMeshes[player]=m
	
	m=AVR:AddCircleWarning(self.scene,player,true,4,nil,1,0.5,0,nil,nil,true)
	m:SetTimer(15)
	self.unboundMeshes2[player]=m	
end
function mod:UnboundPlagueRemoved(player, spellId, _, _, spellName)
--	if bit.band(self.db.profile[72855], BigWigs.C.MESSAGE) ~= BigWigs.C.MESSAGE then return end
	
	local m=self.unboundMeshes[player]
	if m then 
		m:Remove()
		self.unboundMeshes[player]=nil
	end
	local m=self.unboundMeshes2[player]
	if m then 
		m:Remove()
		self.unboundMeshes2[player]=nil
	end
end

function mod:PlagueSickness(player, spellId, _, _, spellName)
	local m=self.sicknessMeshes[player]
	if m then m:Remove() end
	
	_, _, _, _, _, duration, expirationTime = UnitDebuff(player, spellName)
	if not duration or not expirationTime then return end
	
	m=AVR:AddCircleWarning(self.scene,player,true,2,nil,0,1,0,nil,nil,true)
	m:SetTimer(duration,expirationTime-duration)
	self.sicknessMeshes[player]=m
end
function mod:PlagueSicknessRemoved(player, spellId, _, _, spellName)
	local m=self.sicknessMeshes[player]
	if m then 
		m:Remove()
		self.sicknessMeshes[player]=nil
	end
end

function mod:BigWigs_Message(message, module, key, text, color, noraidsay, sound, broadcastOnly, icon)
	if key==72295 then
		if not self.scene then return end
		key = GetSpellInfo(key)
		if bit.band(self.db.profile[key], BigWigs.C.MESSAGE) ~= BigWigs.C.MESSAGE then return end
		
		if module:GetName()=="Festergut" then return end -- this message is also sent on Festergut heroic
		
		if broadcastOnly then return end
		local target=AVR_BigWigs.getTargetFromMessage(text)
		
		if target then
			AVR:AddCircleWarning(self.scene,target,false,5,5)
		end
	end
end
